package l09_threads;

import utilities.ThreadHelperMethods;

public class SynchronizedBlock extends Thread {

	private static int n = 15;
	private final static Object lock = new Object();

	@Override
	public void run()	{

		while (true) {
//			synchronized (lock) {
				if (n == 0) break;
				System.out.println("Msg from " + getName() + ": n = " + n);
				ThreadHelperMethods.safeSleep(1000);
				n--;
//			}
			ThreadHelperMethods.safeSleep(1100);
		}
		System.out.println("Thread " + getName() + " exiting with n = " + n);
	}

	public static void main(String[] args) {
		int numberOfThreads = (args.length == 0) ? 2 : Integer.parseInt (args[0]);
		for (int i = 0; i < numberOfThreads; i++) {
			new SynchronizedBlock().start();
		}
	}
}

