package l09_threads;

import utilities.ThreadHelperMethods;

public class TwoThreadsTest {
	static class SimpleThread extends Thread {

		SimpleThread(String str) {
			super(str);
		}

		@Override
		public void run() {
			for (int i = 0; i < 5; i++) {
				System.out.println(getName() + " with value " + i);
				ThreadHelperMethods.safeSleep(1000);
			}
			System.out.println(getName() + " I'm DONE!");
		}
	}

	public static void main (String[] args) {

		int n = (args.length > 0) ? Integer.parseInt(args[0]) : 2;
		for (int i = 0; i < n; i++) {
			new SimpleThread("I am thread " + i).start();
		}
	}
}

