package l09_threads;

import utilities.ThreadHelperMethods;

public class TwoThreadsTest2 {

	static class SimpleThread implements Runnable {
		private final Thread simple;

		SimpleThread(String str) {
			simple = new Thread(this, str);
			simple.start();
		}

		@Override
		public void run() {
			for (int i = 0; i < 5; i++) {
				System.out.println(simple.getName() + " with value " + i);
				ThreadHelperMethods.safeSleep(1000);
			}
			System.out.println(simple.getName() + " I'm DONE!");
		}
	}

	public static void main (String[] args) {
		int n = (args.length > 0) ? Integer.parseInt(args[0]) : 2;
		for (int i = 0; i < n; i++) {
			new SimpleThread("I am Thread " + i);
		}
	}
}

