package l09_threads;

import utilities.ThreadHelperMethods;

public class WaitingForThread {

	static class Worker extends Thread {
		@Override
		public void run() {
			System.out.println(getName() + ": Entered");
			System.out.println(getName() + ": Working ...");
			ThreadHelperMethods.safeSleep(5000);
			System.out.println(getName() + ": Done with work");
		}
	}

	public static void main(String[] argv) {
		int num = (argv.length == 0) ? 5 : Integer.parseInt(argv[0]);
		Worker[] workers = new Worker[num];

		for (int i = 0; i < num; i++) {
			workers[i] = new Worker();
			workers[i].start();
		}
		for (Thread worker : workers) {
			ThreadHelperMethods.safeJoin(worker);
		}
		System.out.println("Testcase completed");
	}
}

