package l09_threads;

public class ThreadDemo implements Runnable {

	@Override
	public void run() {
		System.out.print("run() called from " + Thread.currentThread());
	}

	public static void main(String[] args) {

		Thread thread = new Thread(new ThreadDemo(), "New Thread");

		//	The java.lang.Thread.toString() method returns a string
		//	representation of this thread, including the thread's name,
		//	priority, and thread group.

		System.out.println("current thread = " + Thread.currentThread());
		System.out.println("thread created = " + thread);

		// this will call run() function
		thread.start();
	}
} 
