package l09_threads;

import utilities.ThreadHelperMethods;

public class TimeTest {

	public static void main(String[] args) {
		int delay = (args.length > 0) ? Integer.parseInt(args[0]) : 5;
		System.out.println("Infinite loop starts");
		long startTime = System.nanoTime();
		if(delay > 0) {
			new Timeout(delay * 1000, startTime, "Timed out");
			System.out.println("Should timeout in " + delay + " seconds\n");
		}
		while(true) {
			System.out.println("Still in the loop ... " +
				(System.nanoTime() - startTime) / 1000000 + "[ms] passed");
			ThreadHelperMethods.safeSleepFor(1000);
		}
	}
}

