package l09_threads;

import utilities.ThreadHelperMethods;

public class TwoThreadsTest1 {
	static class SimpleThread implements Runnable {
		@Override
		public void run() {
			String name = Thread.currentThread().getName();
			for (int i = 0; i < 5; i++) {
				System.out.println(name + " with value " + i);
				ThreadHelperMethods.safeSleep(1000);
			}
			System.out.println(name + " I'm DONE!");
		}
	}

	public static void main (String[] args) {
		int n = (args.length > 0) ? Integer.parseInt(args[0]) : 2;
		for (int i = 0; i < n; i++) {
			new Thread(new SimpleThread(), "I am Thread " + i).start();
		}
	}
}

